'use strict';

var _flowgraph = require('./core/flowgraph');

var _flowgraph2 = _interopRequireDefault(_flowgraph);

var _flownode = require('./core/flownode');

var _flownode2 = _interopRequireDefault(_flownode);

var _classes = require('./factory/classes');

var _classes2 = _interopRequireDefault(_classes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

if (!global._babelPolyfill) {
    require('babel-polyfill');
}

var Ciril = {

    // core/flownode.js
    FlowNode: _flownode2.default,
    Transformer: _flownode.Transformer,
    wrap: _flownode.wrap,

    // FlowGraph API
    // core/flowgraph.js

    // fields for debugging
    _nodes: _flowgraph2.default.nodes,
    _bindings: _flowgraph2.default.bindings,
    _inputs: _flowgraph2.default.inputs,

    // public methods
    register: _flowgraph2.default.register.bind(_flowgraph2.default),
    isRegistered: _flowgraph2.default.isRegistered.bind(_flowgraph2.default),
    remove: _flowgraph2.default.remove.bind(_flowgraph2.default),
    removeAll: _flowgraph2.default.removeAll.bind(_flowgraph2.default),

    bind: _flowgraph2.default.bind.bind(_flowgraph2.default),
    bindAll: _flowgraph2.default.bindAll.bind(_flowgraph2.default),
    bindInputs: _flowgraph2.default.bindInputs.bind(_flowgraph2.default),
    bindAllInputs: _flowgraph2.default.bindAllInputs.bind(_flowgraph2.default),

    unbind: _flowgraph2.default.unbind.bind(_flowgraph2.default),
    unbindAll: _flowgraph2.default.unbindAll.bind(_flowgraph2.default),

    synchronize: _flowgraph2.default.synchronize.bind(_flowgraph2.default),
    synchronizeAll: _flowgraph2.default.synchronizeAll.bind(_flowgraph2.default),
    desynchronize: _flowgraph2.default.desynchronize.bind(_flowgraph2.default),
    desynchronizeAll: _flowgraph2.default.desynchronizeAll.bind(_flowgraph2.default),

    nodeFromUuid: _flowgraph2.default.nodeFromUuid.bind(_flowgraph2.default),
    getNodeState: _flowgraph2.default.getNodeState.bind(_flowgraph2.default),

    update: _flowgraph2.default.update.bind(_flowgraph2.default),
    updateAll: _flowgraph2.default.updateAll.bind(_flowgraph2.default),
    updateSync: _flowgraph2.default.updateSync.bind(_flowgraph2.default),
    updateAllSync: _flowgraph2.default.updateAllSync.bind(_flowgraph2.default),

    flush: _flowgraph2.default.flush.bind(_flowgraph2.default),
    clear: _flowgraph2.default.clear.bind(_flowgraph2.default),

    // Factory methods

    // factory/classes.js
    createClass: _classes2.default,
    createMixin: _classes.createMixin
};

module.exports = Ciril;